<p>This rule checks for the implementation of a proper authentication failure handling mechanism. It ensures that after 6 failed login attempts, the account is locked for 30 minutes to prevent brute-force attacks.</p>

<h2>Noncompliant Code Example</h2>
<pre>
public class DomainUserDetailsService {
  public void authenticateUser(String username, String password) {
    int failedAttempts = getFailedAttempts(username);
    if (failedAttempts >= 6) { // Noncompliant
      // Lockout mechanism is missing
    }
  }
}
</pre>

<h2>Compliant Solution</h2>
<pre>
public class DomainUserDetailsService {
  public void authenticateUser(String username, String password) {
    int failedAttempts = getFailedAttempts(username);
    if (failedAttempts >= 6) {
      updateLockStatus(username, true); // Compliant
      // Lockout mechanism implemented
    }
  }

  private int getFailedAttempts(String username) {
    // Method to get the number of failed attempts
  }

  private void updateLockStatus(String username, boolean lock) {
    // Method to lock the account
  }
}
</pre>
